<?php

//////////
///
///   db.inc.php
///
//////////

require_once('lib/err.inc.php');



$dbconn = false;

$dbdata = parse_ini_file('etc/RCSDB.ini', true);
$dbdata = $dbdata['dbdata'];



function _db_init()
{
   global $dbconn, $dbdata;

   if(!($dbconn = mysql_connect($dbdata['host'], $dbdata['user'], $dbdata['pass']))) {
      return false;
   }
   if(!mysql_select_db($dbdata['db'], $dbconn)) {
      return false;
   }
   if(!mysql_set_charset('utf8')) {
      return false;
   }

   return true;
}

function _db_escape(&$arg)
{
   global $dbconn;

   switch(gettype($arg)) {
      case 'string':
         if(($arg = mysql_real_escape_string($arg, $dbconn)) === false) {
            return $GLOBALS['err_db']['generic'];
         }
         break;
      case 'array':
      case 'object':
         foreach($arg as $k => &$a) {
            if($k[0] != '_') {
               $ret = _db_escape($a);
               if(is_object($ret)) {
                  return $ret;
               }
            }
         }
         break;
   }

   return true;
}

function db_escape($args)
{
   global $dbconn;

   if(!$dbconn) {
      if(!_db_init()) {
         return $GLOBALS['err_db']['generic'];
      }
   }

   foreach($args as $key => &$arg) {
      if($key[0] != '_') {
         $ret = _db_escape($arg);
         if(is_object($ret)) {
            return $ret;
         }
      }
   }

   return true;
}

function db_escape_file(&$content)
{
   $fp = tmpfile();
   for($i = 0; $i < strlen($content); $i += 1048576) {
      $chunk = substr($content, $i, 1048576);
      $ret = db_escape(array(&$chunk));
      if(is_object($ret)) {
         return $ret;
      }
      fwrite($fp, $chunk);
   }
   rewind($fp);
   $content = '';
   $content = stream_get_contents($fp);
   fclose($fp);

   return true;
}

function db_query($sql, $err_map = false)
{
   global $dbconn;

   if(!$dbconn) {
      if(!_db_init()) {
         return $GLOBALS['err_db']['generic'];
      }
   }

   if(!($result = mysql_query($sql, $dbconn))) {
      if(isset($err_map[mysql_errno($dbconn)])) {
         return $err_map[mysql_errno($dbconn)];
      }
      return array('faultCode' => $GLOBALS['errn']['db'] + mysql_errno($dbconn), 'faultString' => mysql_error($dbconn));
   }

   if($result === true) {
      return true;
   }

   if(mysql_num_rows($result) == 0) {
      mysql_free_result($result);
      return false;
   }

   $ret = array();

   while($row = mysql_fetch_object($result)) {
     array_push($ret, $row);
   }

   mysql_free_result($result);

   return $ret;
}

?>
