<?php

//////////
///
///   err.inc.php
///
//////////

$errn = array('auth'     =>  1100,
              'user'     =>  1200,
              'group'    =>  1300,
              'activity' =>  1400,
              'validity' =>  1500,
              'backdoor' =>  1600,
              'member'   =>  1700,
              'assign'   =>  1800,
              'log'      =>  1900,
              'config'   =>  2000,
              'upload'   =>  2100,
              'download' =>  2200,
              'priority' =>  2300,
              'db'       => 10000);

$err_auth     = array('failed'           => array('faultCode' => $errn['auth']     + 1, 'faultString' => 'Authentication failed'));

$err_user     = array('exists'           => array('faultCode' => $errn['user']     + 1, 'faultString' => 'User already exists'),
                      'empty'            => array('faultCode' => $errn['user']     + 2, 'faultString' => 'No such user'),
                      'nogroup'          => array('faultCode' => $errn['user']     + 3, 'faultString' => 'No groups'));

$err_group    = array('exists'           => array('faultCode' => $errn['group']    + 1, 'faultString' => 'Group already exists'),
                      'empty'            => array('faultCode' => $errn['group']    + 2, 'faultString' => 'No such group'),
                      'nouser'           => array('faultCode' => $errn['group']    + 3, 'faultString' => 'No users'),
                      'noactivity'       => array('faultCode' => $errn['group']    + 4, 'faultString' => 'No activities'));

$err_activity = array('exists'           => array('faultCode' => $errn['activity'] + 1, 'faultString' => 'Activity already exists'),
                      'empty'            => array('faultCode' => $errn['activity'] + 2, 'faultString' => 'No such activity'),
                      'nobackdoor'       => array('faultCode' => $errn['activity'] + 3, 'faultString' => 'No backdoors'),
                      'novalidity'       => array('faultCode' => $errn['activity'] + 4, 'faultString' => 'No validities'));

$err_validity = array('exists'           => array('faultCode' => $errn['validity'] + 1, 'faultString' => 'Validity already exists'),
                      'invactivity'      => array('faultCode' => $errn['validity'] + 2, 'faultString' => 'Invalid activity'),
                      'empty'            => array('faultCode' => $errn['validity'] + 3, 'faultString' => 'No such validity'));

$err_backdoor = array('exists'           => array('faultCode' => $errn['backdoor'] + 1, 'faultString' => 'Backdoor already exists'),
                      'invactivity'      => array('faultCode' => $errn['backdoor'] + 2, 'faultString' => 'Invalid activity'),
                      'empty'            => array('faultCode' => $errn['backdoor'] + 3, 'faultString' => 'No such backdoor'),
                      'nolog'            => array('faultCode' => $errn['backdoor'] + 4, 'faultString' => 'No logs'));

$err_member   = array('exists'           => array('faultCode' => $errn['member']   + 1, 'faultString' => 'User already member of group'),
                      'invgroupuser'     => array('faultCode' => $errn['member']   + 2, 'faultString' => 'Invalid group or user'));

$err_assign   = array('exists'           => array('faultCode' => $errn['assign']   + 1, 'faultString' => 'Group already assigned to activity'),
                      'invactivitygroup' => array('faultCode' => $errn['assign']   + 2, 'faultString' => 'Invalid activity or group'));

$err_log      = array('invbackdoor'      => array('faultCode' => $errn['log']      + 1, 'faultString' => 'Invalid backdoor'),
                      'empty'            => array('faultCode' => $errn['log']      + 2, 'faultString' => 'No such log'));

$err_config   = array('invbackdoor'      => array('faultCode' => $errn['config']   + 1, 'faultString' => 'Invalid backdoor'),
                      'noconfig'         => array('faultCode' => $errn['config']   + 2, 'faultString' => 'No config'));

$err_upload   = array('empty'            => array('faultCode' => $errn['upload']   + 1, 'faultString' => 'No such upload'),
                      'invbackdoor'      => array('faultCode' => $errn['upload']   + 2, 'faultString' => 'Invalid backdoor'),
                      'noupload'         => array('faultCode' => $errn['upload']   + 3, 'faultString' => 'No uploads'));

$err_download = array('empty'            => array('faultCode' => $errn['download'] + 1, 'faultString' => 'No such download'),
                      'invbackdoor'      => array('faultCode' => $errn['download'] + 2, 'faultString' => 'Invalid backdoor'),
                      'nodownload'       => array('faultCode' => $errn['download'] + 3, 'faultString' => 'No download'));

$err_priority = array('invlog'           => array('faultCode' => $errn['config']   + 1, 'faultString' => 'Invalid log'),
                      'nopriority'       => array('faultCode' => $errn['config']   + 2, 'faultString' => 'No priority'));

$err_db       = array('generic'          => array('faultCode' => $errn['db']       + 0, 'faultString' => 'Generic database error'));

?>
