<?php

//////////
///
///   build.inc.php
///
//////////

require_once('lib/commons.inc.php');



if($al & AL_TECH) {
   $dm['build.getdll']     ['function'] = 'build_getdll';
//   $dm['build.getdll']    ['signature'] = array(array($xmlrpcBase64));      // return value
}

if($al & AL_TECH) {
   $dm['build.getcert']    ['function'] = 'build_getcert';
//   $dm['build.getcert']   ['signature'] = array(array($xmlrpcBase64));      // return value
}

if($al & AL_TECH) {
   $dm['build.getsign']    ['function'] = 'build_getsign';
//   $dm['build.getsign']   ['signature'] = array(array($xmlrpcString));      // return value
}



/***************\
*   FUNCTIONS   *
\***************/

function build_getdll()
{
   $sql  = "SELECT `dll` ";
   $sql .= "FROM `build`";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   xmlrpc_set_type($ret[0]->dll, 'base64');

   return $ret[0]->dll;
}

function build_getcert()
{
   $sql  = "SELECT `cert` ";
   $sql .= "FROM `build`";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   xmlrpc_set_type($ret[0]->cert, 'base64');

   return $ret[0]->cert;
}

function build_getsign()
{
   $sql  = "SELECT `sign` ";
   $sql .= "FROM `build`";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   $ret = $ret[0]->sign;

   return $ret;
}

?>
