<?php

//////////
///
///   upload.inc.php
///
//////////
///
///   upload_add($backdoor, $filename, $content)
///   upload_del($upload)
///   upload_enum($backdoor)
///   upload_get($upload)
///   upload_getcontent($upload)
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['upload.add']['function'] = 'upload_add';
//   $dm['upload.add']['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                $xmlrpcString,     // $backdoor
//                                                $xmlrpcString,     // $filename
//                                                $xmlrpcBase64,     // $content
//                                                $xmlrpcString));   // $contentfile
}

if($al & AL_SERV) {
   $dm['upload.del']['function'] = 'upload_del';
//   $dm['upload.del']['signature'] = array(array($xmlrpcBoolean,   // return value
//                                                $xmlrpcInt));     // $upload
}

if($al & AL_SERV) {
   $dm['upload.enum']['function'] = 'upload_enum';
//   $dm['upload.enum']['signature'] = array(array($xmlrpcArray,      // return value
//                                                 $xmlrpcString));   // $backdoor
}

if($al & AL_SERV) {
   $dm['upload.get']['function'] = 'upload_get';
//   $dm['upload.get']['signature'] = array(array($xmlrpcStruct,   // return value
//                                                $xmlrpcInt));    // $upload
}

if($al & AL_SERV) {
   $dm['upload.getcontent']['function'] = 'upload_getcontent';
//   $dm['upload.getcontent']['signature'] = array(array($xmlrpcBase64,   // return value
//                                                       $xmlrpcInt));    // $upload
}



/***************\
*   FUNCTIONS   *
\***************/

function upload_add($backdoor, $filename, $content, $contentfile)
{
   $err_map[1452] = $GLOBALS['err_upload']['invbackdoor'];

   if(isset($contentfile) && isset($_SESSION['upload'][$contentfile])) {
      $_content = file_get_contents(sys_get_temp_dir().'/'.$contentfile);
      unlink(sys_get_temp_dir().'/'.$contentfile);
      unset($_SESSION['upload'][$contentfile]);
   } else {
      $content = $content->scalar;
   }

   $ret = db_escape(array(&$backdoor,
                          &$filename,
                          &$content,
                          &$contentfile));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = trace('upload.add', $backdoor, $filename);

   if(is_object($ret)) {
      return $ret;
   }

   if(isset($_content)) {
      $ret = db_escape_file($_content);
      if(is_object($ret)) {
         return $ret;
      }
      $content = &$_content;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }
   
   $backdoor_id = $ret[0]->backdoor_id;
   
   $sql  = "INSERT INTO `upload` (`backdoor_id`, ";
   $sql .=                       "`filename`, ";
   $sql .=                       "`content`) ";
   $sql .= "VALUES ('$backdoor_id', ";
   $sql .=         "'$filename', ";
   $sql .=         "'";
   $sql .=           $content;
   $sql .=          "')";

   return db_query($sql, $err_map);
}

function upload_del($upload_id)
{
   $ret = db_escape(array(&$upload_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "DELETE FROM `upload` ";
   $sql .= "WHERE `upload_id` = $upload_id";

   return db_query($sql);
}

function upload_enum($backdoor)
{
   $ret = db_escape(array(&$backdoor));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }
   
   $backdoor_id = $ret[0]->backdoor_id;
   
   $sql  = "SELECT `upload_id` AS `upload` ";
   $sql .= "FROM `upload` ";
   $sql .= "WHERE `backdoor_id` = '$backdoor_id'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_upload']['noupload'];
   }

   foreach($ret as &$r) {
      $r = (integer)$r->upload;
   }

   return $ret;
}

function upload_get($upload_id)
{
   $ret = db_escape(array(&$upload_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `filename` ";
   $sql .= "FROM `upload` ";
   $sql .= "WHERE `upload_id` = $upload_id";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_upload']['empty'];
   }

   return $ret[0];
}

function upload_getcontent($upload_id)
{
   $ret = db_escape(array(&$upload_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `content` ";
   $sql .= "FROM `upload` ";
   $sql .= "WHERE `upload_id` = $upload_id";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_upload']['empty'];
   }

   xmlrpc_set_type($ret[0]->content, 'base64');

   return $ret[0]->content;
}

?>
