<?php

require_once('functions.inc.php');

function loginaction()
{
   if(isset($_POST['authuser']) && isset($_POST['authpass'])) {
      login($_POST['authuser'], $_POST['authpass']);
   }

   return;
}

function logoutaction()
{
   logout();

   return;
}

function addaction()
{
   $level = 0;

   $level |= (isset($_POST['admn']) ? AL_ADMN : 0);
   $level |= (isset($_POST['view']) ? AL_VIEW : 0);
   $level |= (isset($_POST['tech']) ? AL_TECH : 0);
   $level |= (isset($_POST['serv']) ? AL_SERV : 0);

   if(isset($_POST['user']) && isset($_POST['pass'])) {
      adduser($_POST['user'], $_POST['pass'], $level);
   }

   return;
}

function modaction()
{
   foreach($_POST['user'] as $num => $user) {
      $level = 0;
      $level |= (isset($_POST['admn'][$num]) ? AL_ADMN : 0);
      $level |= (isset($_POST['view'][$num]) ? AL_VIEW : 0);
      $level |= (isset($_POST['tech'][$num]) ? AL_TECH : 0);
      $level |= (isset($_POST['serv'][$num]) ? AL_SERV : 0);

      if(isset($_POST['pass'][$num])) {
         $pass = $_POST['pass'][$num];
      }

      moduser($user, $pass, $level);
   }

   return;
}

function delaction()
{
   if(isset($_GET['user'])) {
      deluser($_GET['user']);
   }

   return;
}

$action = (isset($_GET['action']) ? $_GET['action'] : '');

switch($action) {
   case 'add':
      if(checklevel(AL_ADMN)) {
         addaction();
      }
      break;
   case 'mod':
      if(checklevel(AL_ADMN)) {
         modaction();
      }
      break;
   case 'del':
      if(checklevel(AL_ADMN)) {
         delaction();
      }
      break;
   case 'login':
      loginaction();
      break;
   case 'logout':
      logoutaction();
      break;
   default:
      break;
}

if(checklevel(AL_ADMN)): 

$users = showuser();
$i = 0;

?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<link rel="stylesheet" href="rcs.css" type="text/css">
</head>
<body>
<center>
<img src="img/logo.gif" style="float: left;">
<br>
<h1>HackingTeam RCS Admin Panel</h1>
Welcome <b><?=htmlspecialchars($_SESSION['authuser'])?></b> (<a href="?action=logout">logout</a>)
<br><br><br>
<center>
<table border="0">
<tr class="title">
<td align="center"><b>Username</b></td>
<td align="center"><b>Password</b></td>
<td align="center"><img src="img/admn.gif" alt="Admin" title="Admin"></td>
<td align="center"><img src="img/view.gif" alt="Viewer" title="Viewer"></td>
<td align="center"><img src="img/tech.gif" alt="Technician" title="Technician"></td>
<td align="center"><img src="img/serv.gif" alt="Server" title="Server"></td>
<td></td>
</tr>
<form action="<?=$_SERVER['PHP_SELF']?>?action=mod" method="POST">
<?php foreach($users as $user): $user->user = htmlspecialchars($user->user); ?>
<tr class="<?=(($i % 2) ? 'odd' : 'even')?>">
<td><?=$user->user?><input type="hidden" name="user[<?=$i?>]" value="<?=$user->user?>"></td>
<td><input type="password" name="pass[<?=$i?>]"></td>
<td><input type="checkbox" name="admn[<?=$i?>]"<?=(($user->level & AL_ADMN) ? " checked" : '')?>></td>
<td><input type="checkbox" name="view[<?=$i?>]"<?=(($user->level & AL_VIEW) ? " checked" : '')?>></td>
<td><input type="checkbox" name="tech[<?=$i?>]"<?=(($user->level & AL_TECH) ? " checked" : '')?>></td>
<td><input type="checkbox" name="serv[<?=$i?>]"<?=(($user->level & AL_SERV) ? " checked" : '')?>></td>
<td><a href="<?=$_SERVER['PHP_SELF']?>?action=del&user=<?=$user->user?>"><img src="img/del.gif" alt="Delete" title="Delete" border="0"></a></td>
</tr>
<?php $i++; endforeach; ?>
<tr>
<td colspan="7" align="right"><input type="submit" value="MODIFY"></td>
</tr>
</form>
<tr>
<td colspan="7"><br></td>
</tr>
<tr class="title">
<td align="center"><b>Username</b></td>
<td align="center"><b>Password</b></td>
<td align="center"><img src="img/admn.gif" alt="Admin" title="Admin"></td>
<td align="center"><img src="img/view.gif" alt="Viewer" title="Viewer"></td>
<td align="center"><img src="img/tech.gif" alt="Technician" title="Technician"></td>
<td align="center"><img src="img/serv.gif" alt="Server" title="Server"></td>
<td></td>
</tr>
<form action="<?=$_SERVER['PHP_SELF']?>?action=add" method="POST">
<tr class="even">
<td><input type="text" name="user"></td>
<td><input type="password" name="pass"></td>
<td align="center"><input type="checkbox" name="admn"></td>
<td align="center"><input type="checkbox" name="view"></td>
<td align="center"><input type="checkbox" name="tech"></td>
<td align="center"><input type="checkbox" name="serv"></td>
<td></td>
</tr>
<tr>
<td colspan="7" align="right"><input type="submit" value="ADD"></td>
</tr>
</form>
</center>
</body>
</html>
<?php

else:

?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<link rel="stylesheet" href="rcs.css" type="text/css">
</head>
<body>
<img src="img/logo.gif" style="float: left;">
<br><br><br>
<form action="<?=$_SERVER['PHP_SELF']?>?action=login" method="POST">
<center>
<table border="0" bgcolor="#ffffff">
<tr>
<td colspan="2"><img src="img/ht.gif"><br><br></td>
</tr>
<tr>
<td align="right">Username:</td>
<td><input style="width: 150px;" type="text" name="authuser"></td>
</tr>
<tr>
<td align="right">Password:</td>
<td><input style="width: 150px;" type="password" name="authpass"></td>
</tr>
<tr>
<td colspan="2" align="center"><input type="submit" value="LOGIN"><br><br></td>
</tr>
</table>
</center>
</form>
</body>
</html>
<?php

endif;

?>
